<?php
class PAFacileBackend{
	
	static function loadScriptsAndStylesheets(){
		if(self::isPAFacilePage()){ 
			$dir = basename(dirname(__FILE__));
			$PAFacilePluginDir = WP_PLUGIN_URL . '/' .$dir;
			wp_enqueue_script( 'jquery-ui-tabs' );
			wp_enqueue_script('pafacile-jast-core', "$PAFacilePluginDir/scripts/JAST.src.js"  );
			wp_enqueue_script('pafacile-jast-popup', "$PAFacilePluginDir/scripts/JAST-popupbox.src.js", array('pafacile-jast-core')  );
			wp_enqueue_script('pafacile-jast-validator', "$PAFacilePluginDir/scripts/JAST-validator.src.js", array('pafacile-jast-core')  );
			
			wp_enqueue_style('pafacile-admin', "$PAFacilePluginDir/admin-pafacile.css", array(), TOSENDIT_PAFACILE_VERSION);
			wp_enqueue_style('pafacile-admin-print', "$PAFacilePluginDir/print-pafacile.css", array(), TOSENDIT_PAFACILE_VERSION, 'print');
		}
	}
	
	static function isPAFacileEditPage(){
		$p = isset($_GET['page'])?$_GET['page']:'';
		return (self::isPAFacilePage() && (preg_match('/\-edit$/i', $p) || preg_match('/\-new$/i', $p)));
		
	}
	static function isPAFacilePage(){
		# Eliminazione notice
		$p = isset($_GET['page'])?$_GET['page']:'';
		if(preg_match('/toSendIt/i', $p)){
			
			if(preg_match('/tosendit\-pa/i', $p)) return true;
			if(preg_match('/\-pa\?/i', $p)) return true;
			
			if(preg_match('/PAFacile/i', $p)) return true;
			
		} 
		
		return false;
	}
	
	
	static function setAdminHeader(){
		
		if(self::isPAFacilePage()){
			/*
			 * Questa sezione è stata spostata nel metodo loadScriptsAndStylesheets() richiamato nel momento più opportuno.
			?>
			<link rel="stylesheet" type="text/css" href="<?php echo toSendItGenericMethods::pluginDirectory(); ?>/admin-pafacile.css" />
			<link rel="stylesheet" type="text/css" href="<?php echo toSendItGenericMethods::pluginDirectory(); ?>/print-pafacile.css" media="print" />
			<script type="text/javascript" src="<?php echo toSendItGenericMethods::pluginDirectory(); ?>/scripts/JAST.src.js" ></script>
			<script type="text/javascript" src="<?php echo toSendItGenericMethods::pluginDirectory(); ?>/scripts/JAST-popupbox.src.js"></script>
			<script type="text/javascript" src="<?php echo toSendItGenericMethods::pluginDirectory(); ?>/scripts/JAST-validator.src.js"></script>
			<?php
			 */
			if(isset($_GET['printout'])){
				?>
				<!--[if lt IE 9]>
				<script type="text/javascript" src="<?php echo toSendItGenericMethods::pluginDirectory(); ?>/scripts/IE9.js"></script>
				<![endif]-->
				<?php
			}
		}
		if(self::isPAFacileEditPage()){
			toSendItGenericMethods::showTinyMCE();
			if(function_exists('insert_cforms_script')) insert_cforms_script();
		}
		
	}

	static function createMenu(){
		global $submenu, $wpdb, $current_user;

		$gruppi = $current_user->groups;
		$creatorFile = 'tosendit-pa';
		$tabellaGruppi = $wpdb->prefix .'groups_rs';
		if(!is_array($gruppi)) $gruppi = array('0'=>0);
		$sql = "select group_name from $tabellaGruppi where id in (" . implode(array_keys($gruppi),',') . ")";
		$ogruppi = $wpdb->get_results($sql);
		
		
		$gruppi = array();
		foreach($ogruppi as $key => $object){ $gruppi[] = $object->group_name; }
		$gruppi = array_values( $gruppi);
		
		$minLevel = TOSENDIT_PAFACILE_DEFAULT_MIN_LEVEL;
		
		toSendItGenericMethods::createMenuStructure(
	  		array(
	  			'pageTitle' 	=> 'PAFacile',
	  			'menuTitle' 	=> 'PAFacile',
	  			'minLevel'  	=> $minLevel,
	  			'menuSlug'		=> $creatorFile,
	  			'imageUrl'		=> TOSENDIT_PAFACILE_PLUGIN_URL .'/images/fiocco20.png',
	  			'defaultAction'	=> array('PAFacilePages','pageWelcome'),
	  			'allowedRoles'	=>  array()
	  		), 
	  		array(	
	  			array(
	  				'pageTitle' => 	'PA-Facile: informazioni sul plugin',
	  				'menuTitle'	=>	'Informazioni',
	  			),
	  			array(
	  				'pageTitle'	=> 	'PAFacile: configurazione del plugin', 
	  				'menuTitle'	=>	'Configurazione',
	  				'handler'	=>	$creatorFile.'?settings',
	  				'action'	=>	array('PAFacilePages','pageSettings'),
	  				'minLevel'	=>	9	# Administrator
	  			)
  			),$gruppi
  		);
	 
		
		 toSendItGenericMethods::createMenuStructure(
	  		array(
	  			'pageTitle' 	=> 'Albo on-line',
	  			'menuTitle' 	=> 'Albo on-line',
	  			'minLevel'  	=> $minLevel,
	  			'menuSlug'		=> 	TOSENDIT_PAFACILE_ALBO_PRETORIO_EDIT_HANDLER,
	  			'imageUrl'		=>	TOSENDIT_PAFACILE_PLUGIN_URL .'/images/albo.png',
	  			'defaultAction'	=> 	array('PAFacilePages','pagePAAlboPretorio'),
	  			'allowedRoles'	=>  array(TOSENDIT_PAFACILE_ROLE_EDITORE_ALBO_PRETORIO, TOSENDIT_PAFACILE_ROLE_ALBO_PRETORIO)
	  		), 
	  		array(	
	  			array(
	  				'pageTitle' => 	'PAFacile - Modifica avviso all\'albo',
	  				'menuTitle'	=>	'Modifica',
	  			),
	  			array(
	  				'pageTitle' => 	'PAFacile - Nuovo avviso all\'albo',
	  				'menuTitle'	=>	'Nuovo',
	  				'handler'	=>	TOSENDIT_PAFACILE_ALBO_PRETORIO_NEW_HANDLER,
	  			),
	  			array(
	  				'pageTitle'	=> 	'PAFacile - Registro delle pubblicazioni', 
	  				'menuTitle'	=>	'Registro',
	  				'handler'	=>	TOSENDIT_PAFACILE_ALBO_PRETORIO_REGISTRO_HANDLER,
	  				'action'	=>	array('PAFacilePages','pagePAAlboRegistro'),
	  			),
	  			array(
	  				'pageTitle'	=> 	'PAFacile - Tipologie di atti pubblicabili', 
	  				'menuTitle'	=>	'Tipi atto',
	  				'handler'	=>	TOSENDIT_PAFACILE_TIPO_ATTO_EDIT_HANDLER,
	  				'action'	=>	array('PAFacilePages','pagePATipoAtto'),
	  				'allowedRoles'=>array(TOSENDIT_PAFACILE_ROLE_EDITORE_ALBO_PRETORIO) 
	  			),
	  			array(
	  				'pageTitle'	=> 	'PAFacile - Nuovo atto da pubblicare', 
	  				'menuTitle'	=>	'Nuovo tipo',
	  				'handler'	=>	TOSENDIT_PAFACILE_TIPO_ATTO_NEW_HANDLER,
	  				'action'	=>	array('PAFacilePages','pagePATipoAtto'),
	  				'allowedRoles'=>array(TOSENDIT_PAFACILE_ROLE_EDITORE_ALBO_PRETORIO)
	  			)
	  		),$gruppi
	  	);

		toSendItGenericMethods::createMenuStructure(
	  		array(
	  			'pageTitle' 	=> 'Bandi & Gare',
	  			'menuTitle' 	=> 'Bandi & Gare',
	  			'minLevel'  	=> $minLevel,
	  			'menuSlug'		=> 	TOSENDIT_PAFACILE_BANDI_EDIT_HANDLER,
	  			'imageUrl'		=>	TOSENDIT_PAFACILE_PLUGIN_URL .'/images/calendar.png',
	  			'defaultAction'	=> 	array('PAFacilePages','pagePABandi'),
	  			'allowedRoles'	=>  array(TOSENDIT_PAFACILE_ROLE_BANDI_GARE)
	  		), 
	  		array(	
	  			array(
	  				'pageTitle' => 	'PAFacile - Gestione Bando, Gara o Graduatoria',
	  				'menuTitle'	=>	'Modifica',
	  			),
	  			array(
	  				'pageTitle' => 	'PAFacile - Nuovo Bando, Gara o Graduatoria',
	  				'menuTitle'	=>	'Nuovo',
	  				'handler'	=>	TOSENDIT_PAFACILE_BANDI_NEW_HANDLER
	  			)
	  		),$gruppi
	  	);

		toSendItGenericMethods::createMenuStructure(
	  		array(
	  			'pageTitle' 	=> 'Delibere',
	  			'menuTitle' 	=> 'Delibere',
	  			'minLevel'  	=> $minLevel,
	  			'menuSlug'		=> 	TOSENDIT_PAFACILE_DELIBERE_EDIT_HANDLER,
	  			'imageUrl'		=>	TOSENDIT_PAFACILE_PLUGIN_URL .'/images/delibere.png',
	  			'defaultAction'	=> 	array('PAFacilePages','pagePADelibere'),
	  			'allowedRoles'	=>  array(TOSENDIT_PAFACILE_ROLE_DELIBERE)
	  		), 
	  		array(	
	  			array(
	  				'pageTitle' => 	'PAFacile - Gestione Delibere',
	  				'menuTitle'	=>	'Modifica',
	  			),
	  			array(
	  				'pageTitle' => 	'PAFacile - Nuova delibera',
	  				'menuTitle'	=>	'Nuova delibera',
	  				'handler'	=>	TOSENDIT_PAFACILE_DELIBERE_NEW_HANDLER
	  			)
	  		),$gruppi
	  	);
	  	
	  	
		toSendItGenericMethods::createMenuStructure(
	  		array(
	  			'pageTitle' 	=> 'Determinazioni',
	  			'menuTitle' 	=> 'Determinazioni',
	  			'minLevel'  	=> $minLevel,
	  			'menuSlug'		=> 	TOSENDIT_PAFACILE_DETERMINE_EDIT_HANDLER,
	  			'imageUrl'		=>	TOSENDIT_PAFACILE_PLUGIN_URL .'/images/determine.png',
	  			'defaultAction'	=> 	array('PAFacilePages','pagePADetermine'),
	  			'allowedRoles'	=>  array(TOSENDIT_PAFACILE_ROLE_DETERMINE)
	  		), 
	  		array(	
	  			array(
	  				'pageTitle' => 	'PAFacile - Gestione determinazioni',
	  				'menuTitle'	=>	'Modifica',
	  			),
	  			array(
	  				'pageTitle' => 	'PAFacile - Nuova determinazione',
	  				'menuTitle'	=>	'Nuova determinazione',
	  				'handler'	=>	TOSENDIT_PAFACILE_DETERMINE_NEW_HANDLER
	  			)
	  		),$gruppi
	  	);
	  	
	  	
		toSendItGenericMethods::createMenuStructure(
	  		array(
	  			'pageTitle' 	=> 'Incarichi professionali',
	  			'menuTitle' 	=> 'Incarichi prof.',
	  			'minLevel'  	=> $minLevel,
	  			'menuSlug'		=> TOSENDIT_PAFACILE_INCARICHI_PROF_EDIT_HANDLER,
	  			'imageUrl'		=>	TOSENDIT_PAFACILE_PLUGIN_URL .'/images/incarichi.png',
	  			'defaultAction'	=> 	array('PAFacilePages','pagePAIncarichiProfessionali'),
	  			'allowedRoles'	=>  array(TOSENDIT_PAFACILE_ROLE_INCARICHI_PROFESSIONALI)
	  		), 
	  		array(	
	  			array(
	  				'pageTitle' => 	'PAFacile - Gestione incarichi',
	  				'menuTitle'	=>	'Modifica',
	  			),
	  			array(
	  				'pageTitle' => 	'PAFacile - Nuovo incarico',
	  				'menuTitle'	=>	'Nuovo incarico',
	  				'handler'	=>	TOSENDIT_PAFACILE_INCARICHI_PROF_NEW_HANDLER
	  			)
	  		),$gruppi
	  	);
	  	
		toSendItGenericMethods::createMenuStructure(
	  		array(
	  			'pageTitle' 	=> 'Ordinanze',
	  			'menuTitle' 	=> 'Ordinanze.',
	  			'minLevel'  	=> $minLevel,
	  			'menuSlug'		=> 	TOSENDIT_PAFACILE_ORDINANZE_EDIT_HANDLER,
	  			'imageUrl'		=>	TOSENDIT_PAFACILE_PLUGIN_URL .'/images/ordinanze.gif',
	  			'defaultAction'	=> 	array('PAFacilePages','pagePAOrdinanze'),
	  			'allowedRoles'	=>	array(TOSENDIT_PAFACILE_ROLE_ORDINANZE)
	  		), 
	  		array(	
	  			array(
	  				'pageTitle' => 	'PAFacile - Modifica Ordinanza',
	  				'menuTitle'	=>	'Modifica',
	  			),
	  			array(
	  				'pageTitle' => 	'PAFacile - Nuova ordinanza',
	  				'menuTitle'	=>	'Nuova',
	  				'handler'	=>	TOSENDIT_PAFACILE_ORDINANZE_NEW_HANDLER
	  			)
  			),$gruppi
  		);
			
		toSendItGenericMethods::createMenuStructure(
	  		array(
	  			'pageTitle' 	=> 'Organi di Governo',
	  			'menuTitle' 	=> 'Organi gov.',
	  			'minLevel'  	=> $minLevel,
	  			'menuSlug'		=> 	TOSENDIT_PAFACILE_ORGANI_EDIT_HANDLER,
	  			'imageUrl'		=>	TOSENDIT_PAFACILE_PLUGIN_URL .'/images/organi.gif',
	  			'defaultAction'	=> 	array('PAFacilePages','pagePAOrgani'),
	  			'allowedRoles'	=>	array(TOSENDIT_PAFACILE_ROLE_ORGANI)
	  		), 
	  		array(	
	  			array(
	  				'pageTitle' => 	'PAFacile - Modifica nominativo',
	  				'menuTitle'	=>	'Modifica',
	  			),
	  			array(
	  				'pageTitle' => 	'PAFacile - Nuovo nominativo',
	  				'menuTitle'	=>	'Nuovo',
	  				'handler'	=>	TOSENDIT_PAFACILE_ORGANI_NEW_HANDLER,
	  			),
	  			array(
	  				'pageTitle'	=> 	'PAFacile - Tipologie degli organi di governo', 
	  				'menuTitle'	=>	'Tipologie',
	  				'handler'	=>	TOSENDIT_PAFACILE_TIPO_ORGANO_EDIT_HANDLER,
	  				'action'	=>	array('PAFacilePages','pagePATipoOrgano'),
	  			),
				array(
	  				'pageTitle'	=> 	'PAFacile - Nuova tipologia di organo', 
	  				'menuTitle'	=>	'Nuovo tipo',
	  				'handler'	=>	TOSENDIT_PAFACILE_TIPO_ORGANO_NEW_HANDLER,
	  				'action'	=>	array('PAFacilePages','pagePATipoOrgano'),
	  			)
	  		),$gruppi
	  	);
		
		if(array_search(TOSENDIT_PAFACILE_ROLE_ORGANIGRAMMA, $gruppi)){
			add_menu_page('Organigramma', 'Organigramma', $minLevel, TOSENDIT_PAFACILE_ORGANIGRAMMA_EDIT_HANDLER, array('PAFacilePages','pagePAOrganigramma'), TOSENDIT_PAFACILE_PLUGIN_URL .'/images/chart_organisation.png');
			add_submenu_page(TOSENDIT_PAFACILE_ORGANIGRAMMA_EDIT_HANDLER, 'PAFacile - nodo dell\'Organigramma', __('Edit'), $minLevel, TOSENDIT_PAFACILE_ORGANIGRAMMA_EDIT_HANDLER, array('PAFacilePages','pagePAOrganigramma'));
			add_submenu_page(TOSENDIT_PAFACILE_ORGANIGRAMMA_EDIT_HANDLER, 'PAFacile - nodo dell\'Organigramma', __('Add New'), $minLevel, TOSENDIT_PAFACILE_ORGANIGRAMMA_NEW_HANDLER, array('PAFacilePages','pagePAOrganigramma'));
		}
		
		
	}
	
}