/**
 * PAFacile Plugin
 */
function pafacilemceplugin_loader_temp__() {
	tinymce.create('tinymce.plugins.PAFacile', {
    	url: '',
    	visualCode: '<hr ' +
					'style="display: block; height: 32px; border: 1px dotted #ccc; ' +
					'background-image: url(\'%url%/img/%type%_%aspect%.png\');' +
					'background-repeat: no-repeat;" ' +
					'title="%shortcode%" />',
    		
    	shortCodeRegExp:/(\[PAFacile ([a-z]+)(.+)?\])/i,
    	
    	is: function(n){
    		var regExp = tinyMCE.selectedInstance.plugins.PAFacile.shortCodeRegExp;
    		if(n==null) return false;
    		if(n.nodeName.toLowerCase() != 'hr') return false;
    		
    		return regExp.test(n.title);
    		
    	},
    	getVisual: function(url, shortcode, type, aspect){
    		var visualCode = tinyMCE.selectedInstance.plugins.PAFacile.visualCode;
    		visualCode = visualCode.replace('%url%', url);
    		visualCode = visualCode.replace('%shortcode%', shortcode);
    		visualCode = visualCode.replace('%type%', type);
    		visualCode = visualCode.replace('%aspect%', aspect);
    		return visualCode;
    	},
    	getInfo : function() {
			return {
				longname : 'PAFacile',
				author : 'toSend.it di Luisa Marra',
				authorurl : 'http://toSend.it',
				infourl : 'http://toSend.it/prodotti/pafacile',
				version : "1.0"
			};
		},
		
        init : function(ed, url) {
			ed.plugins.PAFacile.url = url;
			ed.addButton('PAFacile', {
                title : 'Inserisci un elemento di PAFacile',
                image : url+'/img/albo.png',
                onclick : function() {
		    		var template = new Array() , value = "";
					
					if (ed.plugins.PAFacile.is(tinyMCE.selectedElement) ) {
						ed.inputElement = tinyMCE.selectedElement;
						
						if (tinyMCE.inputElement) {
							value = tinyMCE.inputElement.getAttribute('alt') ? tinyMCE.inputElement.getAttribute('alt') : "";
						}
						// TODO: Impostare i dati
					} else {					
						var inst = tinyMCE.getInstanceById(ed.id);
						var	st = inst.selection.getSel();
						var html = '', value = '';
					}
				
					var 
						width = jQuery(window).width(),
						W = ( 720 < width ) ? 720 : width;
					W = W - 80;
					tb_show( 'Gestione elemento PAFacile', '#TB_inline?width=' + W + '&inlineId=pafacile-mce-form' );
					
					

                }
            });
	    	ed.onNodeChange.add(function(ed, cm, n) {
	    		cm.setActive('PAFacile', ed.plugins.PAFacile.is(n));
            });
	    	
	    	// Viene eseguita quando si passa dall'aspetto visuale al contesto HTML.
			ed.onPostProcess.add(function(ed, o) {
				if (o.get)
					o.content = o.content.replace(/<hr[^>]+title\="(\[PAFacile[^\]]+\])"[^>]+>/g, function(hr) {
						hr = hr.replace(/<hr[^>]+title\="/,'');
						hr = hr.replace(/\]"[^>]\/>$/,']');
						return hr;
					});
			});
			ed.onLoadContent.add(function(ed, o) {
				// console.log (o.content);
			});
	    	// Viene eseguita quando si passa dal contesto HTML all'aspetto visuale.
			ed.onBeforeSetContent.add(function(ed, o) {
				 
				if ( o.content ) {
					o.content = o.content.replace(/(<p>)?\[PAFacile[^\]]+\](<\/p>)?/g, function(shortcode){
						var firstP = 	/^<p>/g,
							lastP = 	/<\/p>$/g,
							startsWithP = (shortcode != shortcode.replace(firstP, '')),
							endsWithP	= (shortcode != shortcode.replace(lastP, '')),
							postFix 	= '';
							
						
						if( endsWithP && startsWithP ){
							// Se lo shortcode è contornato da paragrafi devo rimuoverlo
							shortcode = shortcode.replace(firstP, '');
							shortcode = shortcode.replace(lastP, '');
						}else if(startsWithP){
							// C'è solo il tag iniziale, ma non c'è il tag finale.
							shortcode = shortcode.replace(firstP, '');
							postFix = '<p>';
						}else if(endsWithP){
							shortcode = shortcode.replace(lastP, '');
						}
						var regExp = tinyMCE.selectedInstance.plugins.PAFacile.shortCodeRegExp;
						
						scElements = regExp.exec(shortcode);
						var type= '', aspect = '';
						if(scElements.length>2) type = scElements[2];
						if(scElements.length>3) aspect = scElements[3].trim();
						
						// console.log(scElements);
						var out = tinyMCE.selectedInstance.plugins.PAFacile.getVisual(
								tinyMCE.selectedInstance.plugins.PAFacile.url,
								shortcode,
								type,
								aspect
							);	
						// console.log(out);
						return out+postFix;
					});
				}
			});
			

        },
        createControl : function(n, cm) {
        	return null;
        },
        execCommand: function(editor_id, element, command, user_interface, value) {
    		// Handle commands
    		switch (command) {
    			case "PAFacile":
    				
    				return true;

    		}
        }
    });
    tinymce.PluginManager.add('PAFacile', tinymce.plugins.PAFacile);

    
    jQuery(function(){
		// creates a form to be displayed everytime the button is clicked
		// you should achieve this using AJAX instead of direct html code like this
		var form = jQuery('\
		<div id="pafacile-mce-form">\
			<table id="pafacile-table" class="form-table">\
				<tr>\
					<th><label for="pafacile-mce-type">Tipo:</label></th>\
					<td>\
						<select id="pafacile-mce-type">\
							<option value="alboPretorio">Albo Pretorio</option>\
							<option value="bandi">Bandi di Gara, Concorsi</option>\
							<option value="delibere">Delibere</option>\
							<option value="determine">Determine</option>\
							<option value="incarichiProfessionali">Incarichi Professionali</option>\
							<option value="ordinanze">Ordinanze</option>\
							<option value="organigramma">Organigramma</option>\
							<option value="organi">Organi di Governo</option>\
						</select>\
					</td>\
				</tr>\
				<tr>\
					<th><label for="pafacile-mce-action">Aspetto:</label></th>\
					<td>\
						<select id="pafacile-mce-action">\
							<option value="box">Modulo di ricerca</option>\
							<option value="list">Elenco risultati</option>\
						</select>\
					</td>\
				</tr>\
			</table>\
			<p class="submit">\
				<input type="button" id="pafacile-mce-submit" class="button-primary" value="Conferma" name="submit" />\
			</p>\
			<p>\
				<strong>Nota importante:</strong> la pagina che presenterà un modulo di ricerca o un elenco non deve\
				necessariamente coincidere con la pagina che mostrerà il dettaglio della medesima informazione.\
				Per tale scopo configurare PAFacile (è richiesto un livello amministrativo).\
			</p>\
			<p>\
				<strong>Shortcode per Google Analytics</strong> non è ancora disponibile un\'opzione per la presentazione delle statistiche.\
				Utilizare il codice che segue per presentare le statistiche:\
			</p>\
			<table>\
				<tr>\
					<td>\
						<code>[PAFacile statistiche 365]</code>\
					</td>\
					<td>\
						Per visualizzare le statistiche dell\'ultimo anno\
					</td>\
				</tr>\
				<tr>\
					<td>\
						<code>[PAFacile statistiche 30]</code>\
					</td>\
					<td>\
						Per visualizzare le statistiche a 30 giorni\
					</td>\
				</tr>\
				<tr>\
					<td>\
						<code>[PAFacile statistiche 7]</code>\
					</td>\
					<td>\
						Per visualizzare le statistiche a 7 giorni\
					</td>\
				</tr>\
				<tr>\
					<td>\
						<code>[PAFacile statistiche 1]</code>\
					</td>\
					<td>\
						Per visualizzare le statistiche delle ultime 24 ore\
					</td>\
				</tr>\
			</table>\
			<p>\
				Lo shortcode funzionerà solo se è stata configurata la sezione <em>statistiche</em> di PAFacile.\
			</p>\
		</div>');
		
		var table = form.find('table');
		form.appendTo('body').hide();
		
		// handles the click event of the submit button
		form.find('#pafacile-mce-submit').click(function(){
			var tipo = table.find('#pafacile-mce-type').val();
			var azione = table.find('#pafacile-mce-action').val();

			var shortcode = '[PAFacile ';
			shortcode += tipo;
			shortcode += ' ' + azione;
			shortcode += ']';
			
			var visualCode = 
				tinyMCE.selectedInstance.plugins.PAFacile.getVisual(
					tinyMCE.selectedInstance.plugins.PAFacile.url,
					shortcode,
					tipo,
					azione
				);
			
			// inserts the shortcode into the active editor
			// console.log(visualCode);
			tinyMCE.activeEditor.execCommand('mceInsertContent', 0, visualCode);
			
			// closes Thickbox
			tb_remove();
		});
    });
    
};



pafacilemceplugin_loader_temp__();
