<?php
require_once 'iContents.php';

class BandiGare  extends PAFacilePublicBaseClass implements iContents{
	
	public static function mostra($buffer){
		$itemId = $_GET['itemId'];
		
		if(isset($itemId) && is_numeric($itemId)){
			ob_start();
			// Mostro il dettaglio di un bando
			
			if(!self::dettagli($itemId)){
				unset($_GET['itemId']);
				#return $buffer;
				#self::mostra($buffer);
			}
			$buffer = ob_get_clean();
		}else{
			# Non faccio nulla
		}
		
		return $buffer;
	}
	public static function form($params=null){
		isset($params) && is_array( $params) && extract($params);
		
		$opzioni = get_option('PAFacile_settings');
		$subLevel = 3;
		isset($opzioni['LivelloHeader']) && $subLevel=$opzioni['LivelloHeader'];
		
		$p = get_option('PAFacile_permalinks');
		if(isset($p['bandi_id']) && $p['bandi_id']!=0){
			?>
			<form method="get" action="<?php echo get_permalink($p['bandi_id']) ?>" class="bandi">
				<?php 
				if(isset($_GET['type'])) $type = $_GET['type'];
				?>
				<div class="bando-type">
					<label for="pa_type">Tipo:</label>
					<select name="type" id="pa_type">
						<option value="">Qualsiasi tipo</option>
						<option value="co" <?php echo($type=='co'?'selected="selected"':'');?> >Bando di Concorso</option>
						<option value="ga" <?php echo($type=='ga'?'selected="selected"':'');?> >Bando di Gara</option>
						<option value="gr" <?php echo($type=='gr'?'selected="selected"':'');?> >Graduatoria</option>
						<option value="es" <?php echo($type=='es'?'selected="selected"':'');?> >Esito</option>
						<option value="ba" <?php echo($type=='ba'?'selected="selected"':'');?> >Altri bandi</option>
					</select>
				</div>
				<?php 
				if(isset($_GET['id_office'])) $id_office = $_GET['id_office'];
				?>
				<div class="bando-office-id">
					<label for="id_office">Indetto dall'Ufficio/Area/Settore:</label>
					<?php 
					toSendItPAFacile::buildOfficeSelectorForObject('id_office','id_office','',$id_office, TOSENDIT_PAFACILE_DB_BANDI);
					?>
				</div>
				<div class="bando-date">
					<h<?php echo $subLevel?>>Data Pubblicazione:</h<?php echo $subLevel?>>
					<fieldset>
						<legend>dal</legend>
						<?php 
						if(isset($_GET['dp_dal_yy'])) $dp_dal = $_GET['dp_dal_yy'] .'-'.$_GET['dp_dal_mm'].'-'.$_GET['dp_dal_dd'];
						toSendItGenericMethods::drawDateField('dp_dal',$dp_dal, true);
						?>
					</fieldset>
					<fieldset>
						<legend>al</legend>
						<?php 
						if(isset($_GET['dp_al_yy'])) $dp_al = $_GET['dp_al_yy'] .'-'.$_GET['dp_al_mm'].'-'.$_GET['dp_al_dd'];
						toSendItGenericMethods::drawDateField('dp_al',$dp_al, true);
						?>
					</fieldset>
				</div>
				<div>
					<h<?php echo $subLevel?>>Data Scadenza:</h<?php echo $subLevel?>>
					<fieldset>
						<legend>dal</legend>
						<?php 
						if(isset($_GET['ds_dal_yy'])) $ds_dal = $_GET['ds_dal_yy'] .'-'.$_GET['ds_dal_mm'].'-'.$_GET['ds_dal_dd'];
						toSendItGenericMethods::drawDateField('ds_dal',$ds_dal, true);
						?>
					</fieldset>
					<fieldset>
						<legend>al</legend>
						<?php 
						if(isset($_GET['ds_al_yy'])) $ds_al = $_GET['ds_al_yy'] .'-'.$_GET['ds_al_mm'].'-'.$_GET['ds_al_dd'];
						toSendItGenericMethods::drawDateField('ds_al',$ds_al, true);
						?>
					</fieldset>
				</div>
				<div class="submit-box">
					<input type="submit" value="Cerca..." />
				</div>
			</form>
			<?php
		}else{
			toSendItPAFacileContents::PAFacileConfigurationError();
		}
	}
	public static function elenco($params=null){
		global $wpdb;
		
		$opzioni = get_option('PAFacile_settings');
		$subLevel = 3;
		isset($opzioni['LivelloHeader']) && $subLevel=$opzioni['LivelloHeader'];
		
		$hideNoResults = false;
		/*
			'officeName' 	=> '',
			'type'			=> '',			// Vuoto vuol dire qualsiasi tipo
			'last' 			=> 0,			// Deve mostrare solo gli ultimi avvisi (0 tutti quelli non scaduti)
			'url'			=> $_SERVER['REQUEST_URI'],
			'resultTitle'	=> 'Risultati della ricerca',
		 */
		isset($params) && is_array( $params) && extract($params);
		if($officeName!=''){
			$office = PAFacileDecodifiche::officeIdFromName($officeName);
		}
		$tableName = $wpdb->prefix . TOSENDIT_PAFACILE_DB_BANDI;
		$tableOrganigramma = $wpdb->prefix . TOSENDIT_PAFACILE_DB_USERS_TO_ORGANIGRAMMA;
		$sql = "select * from $tableName ";
		
		$dp_dal = toMySQLDate($_GET['dp_dal_dd'], $_GET['dp_dal_mm'], $_GET['dp_dal_yy'], false);
		$dp_al = toMySQLDate($_GET['dp_al_dd'], $_GET['dp_al_mm'], $_GET['dp_al_yy'], false);
				
		$ds_dal = toMySQLDate($_GET['ds_dal_dd'], $_GET['ds_dal_mm'], $_GET['ds_dal_yy'], false);
		$ds_al = toMySQLDate($_GET['ds_al_dd'], $_GET['ds_al_mm'], $_GET['ds_al_yy'], false);
		
		$filtro = array();
		if($type!='') $filtro[]="tipo ='$type'";
		if($office!='') $filtro[]= "id_ufficio = $office";
		
		$filtro[] = self::buildDataFilter('data_pubblicazione', $dp_dal, $dp_al);
		$filtro[] = self::buildDataFilter('data_scadenza', $ds_dal, $ds_al);
		
		if($_GET['type']!='') $filtro[] .= "tipo='{$_GET['type']}'";
		if($_GET['id_office']!='') $filtro[] .= "id_ufficio='{$_GET['id_office']}'";
		$filtro = self::purgeFilter($filtro);
		
		$filtro = join(' and ',$filtro); 
		if($filtro!=''){
			$filtro = ' where ' . $filtro; //join(' and ', $filtro);
			if(!isset($title)) $title = 'Risultati della ricerca';
		}else{
			#Rimosso nella versione 2.1
			/*
			$filtro = 'where data_scadenza> now()or ADDDATE(data_pubblicazione, 31) >now()  order by data_scadenza asc';
			$title = 'Prossimi alla scadenza/Recenti';
			*/
		}
		$sql = toSendItGenericMethods::applyPaginationLimit("$sql $filtro");
		
		$results = $wpdb->get_results($sql);
		if(count($results)==0){
			if($filtro!='' && !$hideNoResults){
				?>
				<p>Spiacenti, la ricerca effettuata non ha prodotto risultati</p>
				<?php
			} 
		}else{
			if(isset($title)){
				?>
				<h<?php echo $subLevel?>><?php echo $title; ?></h<?php echo $subLevel?>>
				<?php
			} 
			$permalinks = get_option('PAFacile_permalinks');
			$url = get_permalink($permalinks['bandi_id']);
			
			$baseUrl = $url . toSendItGenericMethods::rebuildQueryString(array('pg'));
			
			toSendItGenericMethods::generatePaginationList($tableName, $filtro, $baseUrl);
			?>
			<table cellpadding="0" cellspacing="0">
				<thead>
					<tr>
						<th>Tipo</th>
						<th>Oggetto</th>
						<th>Pubblicato il</th>
						<th>Scade il</th>
						<th><abbr title="Ufficio">Uff.</abbr>/Area/<abbr title="Settore">Sett.</abbr></th>
					</tr>
				</thead>
				<tbody>
					<?php
					
					$url.='?itemId='; 
					$j = 0;
					foreach($results as $i => $row){
						?>
						<tr <?php echo (($j++%2)==0)?'class="odd"':'' ?>>
							<td><?php echo(PAFacileDecodifiche::tipoBando( $row->tipo) ) ?></td>
							<td>
								<a href="<?php echo $url. $row->id?>"><?php echo($row->oggetto) ?></a>
							</td>
							<td><?php echo(toSendItGenericMethods::formatDateTime( $row->data_pubblicazione) ) ?></td>
							<td><?php echo(toSendItGenericMethods::formatDateTime( $row->data_scadenza) ) ?></td>
							<td><?php echo(PAFacileDecodifiche::officeNameById($row->id_ufficio)) ?></td>
						</tr>
						<?php 
					}
					?>
				</tbody>
			</table>
			<?php
		}
	}
	public static function dettagli($id){
		
		global $wpdb;
		
		$opzioni = get_option('PAFacile_settings');
		$subLevel = 3;
		isset($opzioni['LivelloHeader']) && $subLevel=$opzioni['LivelloHeader'];
		
		
		$tableName = $wpdb->prefix . TOSENDIT_PAFACILE_DB_BANDI;
		$sql = 'select * from ' . $tableName .' where id=' . $id .' and data_pubblicazione<="' .date('Y-m-d') .'"';
		$rs = $wpdb->get_row($sql);
		if($rs==null) return false;
		
		$permalinks = get_option('PAFacile_permalinks');
		
		$urlUfficio = get_permalink($permalinks['organigramma_id']);
		$urlBandi = get_permalink($permalinks['bandi_id']);
		$urlUfficio.='?itemId='; 
		
		$arrayInfoHeader = array();
		$arrayInfoHeader['Pubblicato il'] = toSendItGenericMethods::formatDateTime( $rs->data_pubblicazione);
		if($rs->procedura!=null) $arrayInfoHeader['Procedura'] = $rs->procedura;
		if($rs->categoria!=null) $arrayInfoHeader['Categoria'] = $rs->categoria;
		if($rs->id_padre!=null && $rs->id_padre!=0){
			$sql = 'select id,tipo, oggetto from ' . $tableName .' where id=' . $rs->id_padre;
			$rsPadre = $wpdb->get_row($sql);
			$arrayInfoHeader[PAFacileDecodifiche::tipoBando($rsPadre->tipo) . ' a cui si riferisce'] = '<a href="'.$urlBandi.'?itemId='. $rsPadre->id.'">'.$rsPadre->oggetto.'</a>';
		}
		
		$sql = 'select id,tipo, oggetto from '.$tableName .' where id_padre=' . $id;
		$records = $wpdb->get_results($sql);
		$esisteProroga = false;
		if($records){
			for($i=0; $i<count($records); $i++){
				$rsPadre = $records[0];
				if($rsPadre->tipo=='pr'){
					$esisteProroga = true;
					$urlProroga = $urlBandi.'?itemId='. $rsPadre->id;
				}
				$arrayInfoHeader['Collegamento ' . ($i+1). ': '. PAFacileDecodifiche::tipoBando($rsPadre->tipo) . ' riferito al presente documento'] = '<a href="'.$urlBandi.'?itemId='. $rsPadre->id.'">'.$rsPadre->oggetto.'</a>';
			}
			
		}
		
		$area = PAFacileDecodifiche::areaByOfficeId($rs->id_ufficio);
		$arrayInfoHeader['Area/Settore di competenza'] = '<a href="' . ($urlUfficio . $area  ).'">'.PAFacileDecodifiche::officeNameById($area).'</a>';
		if($rs->id_ufficio!=$area){
			$arrayInfoHeader['Ufficio/Settore di competenza'] = '<a href="'.($urlUfficio . $rs->id_ufficio).'">'.PAFacileDecodifiche::officeNameById($rs->id_ufficio).'</a>';
		}
		?>
		<div class="bando type-<?php echo  $rs->tipo?>">
			<h<?php echo $subLevel?>><?php echo PAFacileDecodifiche::tipoBando($rs->tipo) ?>
			<?php 
			if($rs->data_esito!='0000-00-00') echo('(Aggiudicato)');
			?>: <?php echo $rs->oggetto ?></h<?php echo $subLevel?>>
			<?php 
			if($esisteProroga){
				?>
				<div class="notifica">
					<strong>Attenzione!</strong><br /> 
					La data di scadenza riportata nella presente scheda è stata prorogata.
					Per poter consultare i nuovi termini di scadenza, si prega di 
					<a href="<?php echo($urlProroga)?>">consultare la proroga</a>.
				</div>
				<?php
			}
			if(count($arrayInfoHeader!=0)){
				?>
				<dl>
					<?php
					$i=0; 
					foreach($arrayInfoHeader as $key => $value){
						if($value!=null){
							$i+=1;
							$class=(($i%2)==0)?"even":'odd';
							?>
							<dt class="<?php echo $class?>"><?php echo $key ?>:</dt>
							<dd class="<?php echo $class?>"><?php echo $value ?><br /></dd>
							<?php
						}
					}
					?>
				</dl>
				<?php
			}?>
			<hr class="cleft ghosted" />
			<h4><?php echo($rs->tipo=='pr'?'Nuovi t':'T')?>ermini</h4>
			<dl>
				<?php
				if($rs->data_scadenza!='0000-00-00'){
					?>
					<dt>Data scadenza:</dt>
					<dd><?php echo(toSendItGenericMethods::formatDateTime( $rs->data_scadenza)) ?><br /></dd>
					<?php 
				}
				if($rs->data_esito!='0000-00-00'){
				
					?>
					<dt>Data aggiudicazione:</dt>
					<dd><?php echo(toSendItGenericMethods::formatDateTime( $rs->data_esito)) ?><br /></dd>
					<dt>Aggiudicatario:</dt>
					<dd><?php echo($rs->aggiudicatario)?><br /></dd>
					<?php 
				} 
				if($rs->importo!=''){
					?>
					<dt>Importo:</dt>
					<dd>
						<?php 
						echo($rs->importo);
						
						if($rs->annotazioni_importo!=''){
							
							echo("({$rs->annotazioni_importo})");
						}
						?>
						
					</dd>
					<?php 
				}
				?>
			</dl>
			<hr class="cleft ghosted" />
			<p>
			<?php 
			$rs->descrizione = apply_filters( 'default_content', $rs->descrizione);
			// $rs->descrizione = apply_filters( 'the_content', $rs->descrizione);
			
			echo(wpautop(wptexturize( $rs->descrizione) ));
			?>
			</p>
			<h4>Allegati</h4>
			<?php 
			toSendItGenericMethods::displayFileUploadBox($tableName, $rs->id);
			?>
			
		</div>
		<?php 
		return true;
	
	}
}
?>